const promise = require('bluebird')
const dateHelper = require('../../utils/dateHelper')
const db = require('../../utils/db')
const config = require('../../utils/config')
const VideoHelper = require('./VideoHelper');

class HomeHelper {

    async getChef(body) {
        try {
            let where = 'is_chef=1';
            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let selectParams = '*, concat("' + image_path + '", image) as image ';
            let data = await db.select('user', selectParams, where);
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getMeal(body) {
        try {
            let join = [], joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;
            const date = body.date ? body.date : 0;
            //Recipe 
            var where = `meal.user_id= ${user_id} AND date='${date}'`;
            var selectParams = ' meal.*, recipe.name, recipe.cooking_time,recipe.food_type, recipe.recipe_type , recipe.calorie, recipe.view, recipe.category_id, recipe.chef_id,image,video';
            var table_name = 'meal';

            join['join'] = 'recipe.id=meal.recipe_id';
            join['table'] = 'recipe';
            joins[0] = join;

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = '';
            datas['order_by'] = '';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getChefById(body) {
        try {
            const chef_id = body.chef_id ? body.chef_id : 0;
            let where = `id=${chef_id}`;
            const image_path = config.IMAGE_BASE_PATH + 'user/';
            let selectParams = '*, concat("' + image_path + '", image) as image ';
            let data = await db.getById('user', selectParams, where);
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getRelatedRecipe(body) {
        try {
            let joins = [], datas = [];
            const category_id = body.category_id ? body.category_id : 0;
            const user_id = body.user_id ? body.user_id : 0;
            //Recipe 
            var where = `recipe.category_id= ${category_id}`;
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = '';
            datas['order_by'] = '';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getRecipeByChefId(body) {
        try {
            let join = [], joins = [], datas = [];
            const chef_id = body.chef_id ? body.chef_id : 0;
            const user_id = body.user_id ? body.user_id : 0;
            //Recipe 
            var where = `recipe.chef_id= ${chef_id}`;
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = '';
            datas['order_by'] = '';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getFavoritesRecipeList(body) {
        try {
            let join = [], joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;

            //Video 
            var where = `favorites.user_id= ${user_id}`;
            var selectParams = ' recipe.*';
            var table_name = 'favorites';

            join['join'] = 'recipe.id=favorites.recipe_id';
            join['table'] = 'recipe';
            joins[0] = join;

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = '';
            datas['order_by'] = '';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);

            await VideoHelper.getRecipeDetail(recipe, user_id);


            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getRecipeVideo(body) {
        try {
            let join = [], joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;

            //Video 
            var where = '';
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            // join['join'] = 'recipe.id=favorites.recipe_id';
            // join['table'] = 'recipe';
            // joins[0] = join;

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = '';
            datas['order_by'] = '';
            datas['group_by'] = '';
            datas['joins'] = joins;
            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async searchRecipe(body) {

        try {
            let join = [], joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;
            const name = body.name ? body.name : '0';

            //Video 
            var where = `recipe.name Like "%${name}%"`;
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = '';
            datas['order_by'] = '';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;

            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async bannerRecipe(body) {
        try {
            let joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;
            //Recipe 
            var where = ``;
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = 'id';
            datas['order_by'] = 'desc';
            datas['limit'] = '5';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async bestRecipe(body) {
        try {
            let joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;
            //Recipe 
            var where = ``;
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = 'view';
            datas['order_by'] = 'desc';
            datas['limit'] = '10';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async trendingRecipe(body) {
        try {
            let joins = [], datas = [];
            const user_id = body.user_id ? body.user_id : 0;
            //Recipe 
            var where = ``;
            var selectParams = ' recipe.*';
            var table_name = 'recipe';

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = 'RAND()';
            datas['order_by'] = '';
            datas['limit'] = '10';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            await VideoHelper.getRecipeDetail(recipe, user_id);

            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

    async getComment(body) {
        try {
            let joins = [], datas = [];
            const recipe_id = body.recipe_id ? body.recipe_id : '0';

            var table_name = 'comment';
            const image_path = config.IMAGE_BASE_PATH + 'user/';
            joins = [{ join: 'user.id=comment.user_id', table: 'user' }];
            var selectParams = 'comment.*, user.name,concat("' + image_path + '", user.image) as image';

            //comment 
            var where = ` recipe_id=${recipe_id} `;

            datas['where'] = where;
            datas['table'] = table_name;
            datas['selectParams'] = selectParams;
            datas['order_by_field'] = 'id';
            datas['order_by'] = 'DESC';
            datas['limit'] = '100';
            datas['group_by'] = '';
            datas['joins'] = joins;

            let recipe = await db.get_join(datas);
            let data = recipe;
            return { data };
        } catch (error) {
            return promise.reject(error)
        }
    }

}

module.exports = new HomeHelper()