const db = require('../../utils/db')
const promise = require('bluebird')
const joi = require('joi')
const joiValidator = require('../../utils/joiValidator')

/**
 * This CommonValidator class contains car brand model and type add edit list related API's validation.
 */

class CommonValidator {

    async addRemoveFavoritesValidator(body) {
        try {
            let schema = joi.object().keys({
                recipe_id: joi.number().integer().required(),
                user_id: joi.number().integer().required()
            })
            await joiValidator.validateJoiSchema(body, schema);
        } catch (error) {
            return promise.reject(error)
        }
    }

    async addRatingValidator(body) {
        try {
            let schema = joi.object().keys({
                recipe_id: joi.number().integer().required(),
                user_id: joi.number().integer().required(),
                ratings: joi.number().integer().required()
            })
            await joiValidator.validateJoiSchema(body, schema);
        } catch (error) {
            return promise.reject(error)
        }
    }

    async addCommentValidator(body) {
        try {
            let schema = joi.object().keys({
                recipe_id: joi.number().integer().required(),
                user_id: joi.number().integer().required(),
                name: joi.string().required(),
            })
            await joiValidator.validateJoiSchema(body, schema);
        } catch (error) {
            return promise.reject(error)
        }
    }



}

module.exports = new CommonValidator()